<template lang="pug">
  .comment-form
    //- Simple editor (see configs below for restrictions)
    //- TODO: dynamically retrieve the maximum Note length
    vue-simplemde(
      v-model="content"
      v-validate="{ max: 5000 }"
      data-vv-as="note"
      name="note"
      :highlight="false"
      :configs="config"
      ref="markdownEditor"
    )

    //- Button row
    .comment-bottom.d-flex.mt-5(style="flex-direction:row-reverse;" :class="{ thread: !inReplyTo }")
      //- All buttons are aligned on the right
      .comment-right.d-flex.mb-5
        //-
          md-button.md-dense
            | #[span.mr-1 Annotate ]
            | #[i.material-icons(tabindex="-1" style="font-size:1.1rem;") format_quote]
          md-button.md-dense
            | #[span.mr-1 Tune ]
            | #[i.material-icons(tabindex="-1" style="font-size:1.1rem;") tune]
        md-button.md-dense(@click="cancel()")
          | #[span Cancel]
        
        //- Send/Submit button that will execute a mutation
        apollo-mutation(
          :mutation="$options.createNoteGql"
          :variables=`{
            input: {
              pk: id,
              inReplyTo,
              content
            }
          }`
          :refetchQueries="refetch"
          @done="cancel()"
        )
          template(v-slot="{ mutate, loading, error }")
            md-button.md-dense(
              :disabled="loading"
              @click="mutate()"
            )
              | #[span.mr-1 Send ]
              | #[i.material-icons(tabindex="-1" style="font-size:1.1rem;") send]
</template>

<script>
import VueSimplemde from 'vue-simplemde'

import createNoteGql from '~/apollo/mutations/createNote'

export default {
  createNoteGql,

  components: {
    VueSimplemde
  },
  props: {
    id: {
      type: String,
      required: true,
      default: ''
    },
    inReplyTo: {
      type: String,
      default: ''
    },
    refetchQueries: {
      type: Array,
      required: true
    },
    initialContent: {
      type: String,
      default: ''
    },
    placeholder: {
      type: String,
      default: 'corpus note placeholder'
    }
  },
  data() {
    return {
      content: '',
      config: {
        initialValue: this.initialContent,
        status: false,
        toolbar: false,
        placeholder: this.$i18n.t(this.placeholder),
        autosave: {
          enabled: false,
          uniqueId: this.id
        },
        spellChecker: false,
        autofocus: true,
        shortcuts: {
          toggleSideBySide: null,
          togglePreview: null
        }
      }
    }
  },
  methods: {
    cancel() {
      this.content = ''
      this.$emit('cancel')
    },
    send() {
      this.$emit('send')
    },
    refetch() {
      return this.refetchQueries
    }
  },
  $_veeValidate: {
    validator: 'new'
  }
}
</script>

<style lang="postcss" scoped>
.comment-bottom {
  position: relative;

  &.thread::before {
    content: '';
    display: block;
    height: 100%;
    width: 2px;
    position: absolute;
    left: 11px;
    border-radius: 50%;
    background: rgba(var(--color-foreground), 1);
  }
}
</style>

<style>
@import 'simplemde/dist/simplemde.min.css';

.comment-form .CodeMirror,
.comment-form .CodeMirror-scroll {
  min-height: 25px !important;
  border-radius: 4px;
  border: none;
  background-color: rgba(var(--color-foreground), 1);
}
</style>
